﻿Type=Activity
Version=2.52
@EndOfDesignText@



#Region  Activity Attributes 
	#FullScreen: True
	#IncludeTitle: False
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	

End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Dim accSfc As AcceleratedSurface
	Dim m_World As jbWorld
	Dim listWorldBodies As List
	Dim bmpSmiley As Bitmap
	Dim WorldConverter As cJBox2DPixelConverter
	Dim tmrWorldStep As Timer 'used during debugging, as I don't see how to turn off the the accelerated surface timer
	Dim OneMeterY As Float 'used for scaling between Screen and JBox World
End Sub

Sub Activity_Create(FirstTime As Boolean)
	'Do not forget to load the layout file created with the visual designer. For example:
	'Activity.LoadLayout("Layout1")
	
	If FirstTime Then
		tmrWorldStep.Initialize("tmrWorldStep", DateTime.TicksPerSecond/30)
	End If
	
	accSfc.Initialize("accSFC", True)
	Activity.AddView(accSfc, 0, 50dip, 100%x, 100%y - 50dip)
	WorldConverter.Initialize(accSfc.Width, accSfc.Height, 2)
	listWorldBodies.Initialize
	OneMeterY = accSfc.Height/3
	
	SetupWorld
	setupballs
	setDisplayBallSize
	
	'tmrWorldStep.Enabled = True
End Sub

Sub Activity_Resume
	
	accSfc.StartRegularUpdateAndDraw(DateTime.TicksPerSecond/60)
End Sub

Sub Activity_Pause (UserClosed As Boolean)
	accSfc.StopRegularDraw
End Sub


Sub SetupWorld
'for Box2D, need a World
'first define the gravity for your world

Dim fGravity As jbVec2
fGravity.Initialize(0, -10) '0 for x vector, -5 for y vector of the gravity

'can also set whether of not the World should allow bodies to sleep when at rest
'this will save on CPU cycles
'that sounds good, so now setup the world

m_World.Initialize(fGravity, True)

'the world now has a gravity vector assigned, but needs something in it
'for this example, will have a flat surface that balls will fall onto

'the 'ground' and its initial position in the world
Dim groundBodyDef As jbBodyDef


groundBodyDef.position.set(0, 0) 'the center point is on center axis, down 10 meters from world origin

'need to pass 'ground' to the world so it knows where to put it, and need to put the body into some type
'of list to keep track of it later

Dim groundBody As jbBody

groundBody = m_World.createBody(groundBodyDef) 'groundBody now hold pointer to the created object

'now need to shape the ground body
'shapes are normally attached as fixtures to the body

Dim groundShape As jbPolygonShape
groundShape.setAsBox(50, .01) 'the shape is a 100 meters wide, .2 meters tall box, as it is half-height here

groundBody.createFixture2(groundShape, 0) 'fixture attached with 0 mass (by definition for static bodies)

'Dim ac As jbWorld


'i also want walls around the balls on the sides of them

Dim leftWall, rightWall As jbBodyDef
Dim widthXinMeters As Float
widthXinMeters = WorldConverter.getCurrentWidthInMeters
leftWall.position.set(-widthXinMeters/2, 0)
rightWall.position.set(widthXinMeters/2, 0)

WorldConverter.SetLeftEdge(leftWall.position.x)

Dim leftWallBody, rightWallBody As jbBody
leftWallBody = m_World.createBody(leftWall)
rightWallBody = m_World.createBody(rightWall)

Dim wallShape As jbPolygonShape
wallShape.setAsBox(.001, 10)
leftWallBody.createFixture2(wallShape, 0)
rightWallBody.createFixture2(wallShape, 0)

End Sub

Sub setupballs
'Now need to setup some balls to fall out of the sky and hit the ground

	
For i = 0 To 4
   Dim bodydef As jbBodyDef
	bodydef.Type = bodydef.BODYTYPE_DYNAMIC
	bodydef.position.set(-.5 + i/6, 1 + i*.2) 'on centerline, 3 meters up
	Dim body As jbBody = m_World.createBody(bodydef)
	Dim dynamicBall As jbCircleShape
	dynamicBall.m_radius = .1 '.1 meter in radius, .2 meters in height
	
	Dim fixtureDef As jbFixtureDef
	fixtureDef.shape = dynamicBall
	fixtureDef.Density = 10 + Rnd(-2,3)
	fixtureDef.friction = .7 + Rnd(-20, 30)/100
	fixtureDef.restitution = 0.7 +  Rnd(-20, 30)/100
	body.createFixture(fixtureDef)
	
	listWorldBodies.Add(body) 'can either keep track of each body in a list, or iterate thru each body returned by the World object
Next


'WorldConverter.setBottomEdge(-1)
End Sub

Sub tmrWorldStep_tick
	WorldStep
End Sub

Sub WorldStep
	Dim timeStep As Float = 1/60
	Dim velocityIterations As Int = 6
	Dim positionIterations As Int = 2
	
	
	'Run Loop
	Dim oldX, oldY As Float = -1
	Dim position As jbVec2
	Dim angle As Float
	m_World.Step(timeStep, velocityIterations, positionIterations)
	
	
	CheckContact(m_World.ContactList)
	'--------------------------------------------------------
	'Here is where I want to check for collisions, and add bounce sounds when balls hit 
	
	'will not compile if below is uncommented
	'Dim aContact As jbContact 
	
	'acontact = m_world.ContactList
	
	'Dim fixA, fixB As jbFixture
	'fixA = aContact.FixtureA
	'fixB = aContact.FixtureB
	'Here I can make a map, or a list of each body that is currently hitting, so I can turn it some other color
	'also can start a sound to be the bounce sound
	
	
	'--------------------------------------------------------
	
	accSfc.Invalidate


End Sub

Sub accSfc_update(ElapsedTime As Long)
	'Log(ElapsedTime)
	Dim timeStep As Float = 1/60
	Dim velocityIterations As Int = 6
	Dim positionIterations As Int = 2
	
	m_World.Step(timeStep, velocityIterations, positionIterations)
	
'	Dim body As jbBody
'	body = m_World.BodyList
	
	'Log(m_World.BodyCount)
	
	
	
	

End Sub

'this allowed me to at least get to the jbcontact, as I can't instantiate a jbContact
'but again, the Next is a problem
Sub CheckContact(jbContactList As jbContact)

'Log(jbContactList)
	
''	If jbContactList.Next <> Null Then
''		'BeginContact(jbContactList.Next 'again fails because of Next keyword
''	End If
End Sub


'this would be awesome to have!
Sub beginContact(someContact As jbContact)

'from http://www.iforce2d.net/b2dtut/collision-anatomy


'Contact listeners
'Checking the List of contacts becomes inefficient For large scenarios where many collisions are occuring frequently. 
'Setting a contact listener allows you To have Box2D tell you when something interesting happens, rather than you
'doing all the work of keeping track of when things start AND stop touching. A contact listener Is a class (b2ContactListener)
'with four functions which you override As necessary.

'	
''''  very cool if here
'  void beginContact(b2Contact* contact);
'  void endContact(b2Contact* contact);

''''' these would probably be less important, at least for my little brain

'  void PreSolve(b2Contact* contact, const b2Manifold* oldManifold);
'  void PostSolve(b2Contact* contact, const b2ContactImpulse* impulse);
'
'Note that depending on what Is happening, some events give us more than just the b2Contact Object. During the world's Step function, when Box2D detects that one of these events has occured, it will 'call back' to these functions to let you know about it. Practical applications of these 'collision callbacks' will be looked at in other topics, for now we are focusing on when they occur. 

End Sub
'same as above
Sub endContact(someContact As jbContact)

End Sub

Sub accSfc_draw(AC As AcceleratedCanvas)
	'bottom of our 'world is at -10
	'ball starts at + 10, need to do some scaling to make it good
	Dim body As jbBody
	body = m_World.BodyList
	Do While body.Mass = 0 
		body = body.NextBody
	Loop
	

	
	Dim body As jbBody
	body = m_World.BodyList
	'Log(m_World.BodyCount)
	
	
	
	Do While body <> Null
		Dim screenYPosition, screenXposition As Float
		screenYPosition = body.Position.y * OneMeterY
		screenXposition = body.Position.x * OneMeterY
		
		Dim newPosition As jbVec2
		'newPosition = body.Position
		
		newPosition = WorldConverter.ChangeWorldVecToDisplayVec(body.Position)
		
		If body.Mass > 0 Then
			AC.MatrixSetRotate2(body.Angle * -57.295, Bit.ShiftRight(bmpSmiley.Width, 1), Bit.ShiftRight(bmpSmiley.Height, 1))
			'AC.DrawBitmapWithMatrixAt(bmpSmiley,screenXposition + 50%x - bmpSmiley.Width*.5, accSfc.Height - screenYPosition - bmpSmiley.Height*.5, True)
			AC.DrawBitmapWithMatrixAt(bmpSmiley,newPosition.x - bmpSmiley.Width/2 , newPosition.y - bmpSmiley.Height/2, True)
			
			'Log((accSfc.Height - screenYPosition - bmpSmiley.Height*.5))
			
			'AC.DrawBitmapWithMatrixAt(bmpSmiley,newPosition.x, newPosition.y, True)
	
		End If
		
		'''AC.MatrixPreRotate2(180, body.Position.x + 50%x, accSfc.Height - screenYPosition).DrawBitmapWithMatrixAt(bmpSmiley, body.Position.x + 50%x, accSfc.Height - screenYPosition,True)
		body = body.NextBody
	Loop
	'Log("next loop")
	Return
	
''	For Each body As jbBody In listWorldBodies
''		'x and y need to be transformed from meters, to position in our drawing surface
''		'how many meters do we want y to be?  start with 5 meters
''		'therefore, as the body bounces, need to move it
''		
''		'but want the bottom of the ball to hit the bottom of the screen
''		
''		
''		
''		Dim screenYPosition, screenXposition As Float
''		screenYPosition = body.Position.y * OneMeterY
''		screenXposition = body.Position.x * OneMeterY
''		
''		Dim newPosition As jbVec2
''		newPosition = body.Position
''
''		
''		If Not(body.isAwake) Then
''			tmrWorldStep.Enabled = False
''		Else
''			tmrWorldStep.Enabled = True
''		End If
''		'''AC.MatrixPreRotate2(180, body.Position.x + 50%x, accSfc.Height - screenYPosition).DrawBitmapWithMatrixAt(bmpSmiley, body.Position.x + 50%x, accSfc.Height - screenYPosition,True)
''		AC.MatrixSetRotate2(body.Angle * 57.295, Bit.ShiftRight(bmpSmiley.Width, 1), Bit.ShiftRight(bmpSmiley.Height, 1))
''		AC.DrawBitmapWithMatrixAt(bmpSmiley,screenXposition + 50%x - bmpSmiley.Width*.5, accSfc.Height - screenYPosition - bmpSmiley.Height*.5, True)
''		'AC.DrawBitmapAt(bmpSmiley, screenXposition + 50%x - bmpSmiley.Width*.5, accSfc.Height - screenYPosition + bmpSmiley.Height*.5)
''	Next
	
End Sub

Sub accSfc_touch(Action As Int, X As Int, Y As Int, Event As Object)
	tmrWorldStep.Enabled=False
	
	Dim body As jbBody
	Dim nextBody As jbBody
	
	body = m_World.BodyList
	
	Do While body <> Null
		nextBody = body.nextBody
		m_World.destroyBody(body)
		body = nextBody
	Loop
	
	listWorldBodies.Initialize
	WorldConverter.ChangeScale(WorldConverter.getCurrentScale * .8, False)
	setDisplayBallSize
	SetupWorld
	setupballs
'	tmrWorldStep.Enabled = True
	
	
End Sub


Sub setDisplayBallSize
Dim IU As ImageUtils

Dim ballHeight As Float
ballHeight = WorldConverter.JWorldLengthToDisplayLength(.2)


	bmpSmiley = IU.CreateScaledBitmap(LoadBitmap(File.DirAssets, "mysmiley.png"), ballHeight, ballHeight, True)


End Sub


