﻿Type=Activity
Version=2.52
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: True
	#IncludeTitle: False
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Type ShelfParameters (height As Float, width As Float)
	Dim GD As GestureDetector

End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Dim accSfc As AcceleratedSurface
	Dim listOfDominos As List
	Dim listOfShelves As List
	Dim listofBalls As List
	Dim pnlTouch As Panel 'to cature Touch Events above our drawing surface
	Dim dominoWorld As jbWorld 'our new world
	Dim WorldConverter As cJBox2DPixelConverter
	Dim tmrWorldStep As Timer 'needed for debugging
	
	Dim bmpDomino As Bitmap
	Dim bmpShelf As Bitmap
	Dim bmpBall As Bitmap
	
	Dim DominoHeight As Float : DominoHeight = .5
	Dim DominoWidth As Float : DominoWidth = .1
	
	Dim timeStep As Float : timeStep = 1000/50
	
End Sub

Sub Activity_Create(FirstTime As Boolean)

	accSfc.Initialize("accSfc", True)
	Activity.AddView(accSfc, 0, 50dip, 100%x, 100%y-50dip)
	pnlTouch.Initialize("pnlTouch")
	Activity.AddView(pnlTouch, accSfc.Left, accSfc.Top, accSfc.Width, accSfc.Height)
	pnlTouch.Color = Colors.Transparent
	WorldConverter.Initialize(accSfc.Width, accSfc.Height, 10)
	setupDominoBMP
	setupBallBMP
	setupShelfBMP
	tmrWorldStep.Initialize("tmrWorldStep", timeStep)
	GD.SetOnGestureListener(pnlTouch, "Gesture")
	listOfShelves.Initialize
	listOfDominos.Initialize
	listofBalls.Initialize
	setupWorld
	setupdominos
	setupBall(.25, 5)

	Activity.AddMenuItem("Reset", "mnuReset")
	Activity.AddMenuItem("Change Screen Height", "mnuChangeHeight")
	
	
	'tmrWorldStep.Enabled = True
End Sub

Sub Activity_Resume
	accSfc.StartRegularUpdateAndDraw(timeStep)

End Sub

Sub Activity_Pause (UserClosed As Boolean)
	accSfc.StopRegularDraw
End Sub

Sub pnlTouch_Click
	

End Sub

'set all hard surfaces
Sub setupWorld
	'should build the world with how you want things, don't worry about the window to the world
	'so much, As that can be scaled easily In AND out
	
	'for Box2D, need a World
	'first define the gravity for your world

	Dim fGravity As jbVec2
	fGravity.Initialize(0, -10) '0 for x vector

	'can also set whether of not the World should allow bodies to sleep when at rest
	'this will save on CPU cycles
	'that sounds good, so now setup the world

	dominoWorld.Initialize(fGravity, True)

	'the world now has a gravity vector assigned, but needs something in it
	'for this example, will have a flat surface that are stacked dominos

	'we'll put the first shelf at 2 meters height, 
	'it Is 1 meter Long and 2 cm thick
	
	'first definition
	
	Dim shelfDef As jbBodyDef

	shelfDef.position.set(0, 2) 'the center point is on center axis, up 2 meters from world origin
	shelfDef.Type = shelfDef.BODYTYPE_STATIC
	'now the body
	Dim shelfbody As jbBody
	shelfbody = dominoWorld.createBody(shelfDef) 'put that definition in the world and get back pointer
	
	'now need to shape the shelf body
	'shapes are normally attached as fixtures to the body

	Dim shelfShape As jbPolygonShape
	shelfShape.setAsBox(5, .01) 'the shape is 5 meters wide, 2 cm tall box, as it is defined by half-height here
	
	Dim NewShelfParam As ShelfParameters
	NewShelfParam.Initialize
	NewShelfParam.height = .02 '2 centimeters
	NewShelfParam.width = 10 '10 meter
	
	shelfbody.UserData = NewShelfParam
	
	shelfbody.createFixture2(shelfShape, 0) 'fixture attached with 0 mass (by definition for static bodies)
	listOfShelves.Add(shelfbody)
	
	'Dim ac As jbWorld
	
	Dim shelfDef As jbBodyDef
	shelfDef.position.set(3, 0)
	
	Dim shelfbody As jbBody
	shelfbody = dominoWorld.createBody(shelfDef) 'put that definition in the world and get back pointer
	Dim shelfShape As jbPolygonShape
	shelfShape.setAsBox(5, .01) 'the shape is 5 meters wide, 2 cm tall box, as it is defined by half-height here
	
	Dim NewShelfParam As ShelfParameters
	NewShelfParam.Initialize
	NewShelfParam.height = .02 '2 centimeters
	NewShelfParam.width = 10 '10 meter
	
	shelfbody.UserData = NewShelfParam
	
	shelfbody.createFixture2(shelfShape, 0) 'fixture attached with 0 mass (by definition for static bodies)
	listOfShelves.Add(shelfbody)
	
	Dim shelfDef As jbBodyDef
	shelfDef.position.set(-5, 4)
	
	Dim shelfbody As jbBody
	shelfbody = dominoWorld.createBody(shelfDef) 'put that definition in the world and get back pointer
	Dim shelfShape As jbPolygonShape
	shelfShape.setAsBox(5, .01) 'the shape is 5 meters wide, 2 cm tall box, as it is defined by half-height here
	
	Dim NewShelfParam As ShelfParameters
	NewShelfParam.Initialize
	NewShelfParam.height = .02 '2 centimeters
	NewShelfParam.width = 10 '10 meter
	
	shelfbody.UserData = NewShelfParam
	
	shelfbody.createFixture2(shelfShape, 0) 'fixture attached with 0 mass (by definition for static bodies)
	listOfShelves.Add(shelfbody)
	
	
	'WorldConverter.SetLeftEdge(shelfbody.Position.x - .55)
	WorldConverter.SetCenterPoint(0, 2)
	
	
End Sub

Sub setupdominos
	'shelves are built, go to each shelf, calculate how many dominos can fit on each shelf if
	'a domino is 1 cm wide and 4 cm tall, with 2cm between each one, leaving a minimum 1 cm gap
	Dim currentShelfParam As ShelfParameters
	For Each jBody As jbBody In listOfShelves
		currentShelfParam = jBody.UserData
		Dim totaldominos As Int
		
		Dim AllWidth As Float
		AllWidth = DominoWidth + DominoHeight * .8
		
		totaldominos = currentShelfParam.width/AllWidth
		Dim LeftoverGap As Float
		LeftoverGap = (currentShelfParam.width Mod AllWidth)/2
		
		Dim ShelfTop, ShelfLeft As Float
		ShelfTop = jBody.Position.y + currentShelfParam.height/2 'this is where the bottom of the dominos will be resting
		
		ShelfLeft = jBody.Position.x - currentShelfParam.width/2 'this is the left edge of the shelf
		
		'now fill with dominos
		For i = 0 To totaldominos -1 
			
			Dim dominoDef As jbBodyDef
			dominoDef.position.set(ShelfLeft + LeftoverGap + i * DominoWidth + i * DominoHeight*.8 , ShelfTop + DominoHeight/2 + .05)
			'dominoDef.position.set(ShelfLeft + LeftoverGap + i * AllWidth + .01, ShelfTop + DominoHeight/2 + .05)
			dominoDef.Type = dominoDef.BODYTYPE_DYNAMIC 'needs this to move
			
			
			Dim dominoBody As jbBody
			dominoBody = dominoWorld.createBody(dominoDef)
			
			
			Dim dominoShape As jbPolygonShape
			dominoShape.setAsBox(DominoWidth/2, DominoHeight/2) '1 cm wide, 4 cm tall
			
			dominoBody.createFixture2(dominoShape, .1)
			listOfDominos.Add(dominoBody)
		Next
		
''		For i = 0 To totaldominos -1 
''			
''			Dim dominoDef As jbBodyDef
''			dominoDef.position.set(ShelfLeft + LeftoverGap + i * AllWidth + .01, ShelfTop + DominoHeight/2 + .005 + DominoHeight + .05)
''			dominoDef.Type = dominoDef.BODYTYPE_DYNAMIC 'needs this to move
''			
''			
''			Dim dominoBody As jbBody
''			dominoBody = dominoWorld.createBody(dominoDef)
''			
''			
''			Dim dominoShape As jbPolygonShape
''			dominoShape.setAsBox(DominoWidth/2, DominoHeight/2) '1 cm wide, 4 cm tall
''			
''			dominoBody.createFixture2(dominoShape, .1)
''			listOfDominos.Add(dominoBody)
''		Next
	Next

End Sub

Sub clearDominos
	For Each domino As jbBody In listOfDominos	
		dominoWorld.destroyBody(domino)
	Next
	
	listOfDominos.Initialize

End Sub

Sub clearBalls
	For Each ball As jbBody In listofBalls	
		dominoWorld.destroyBody(ball)
	Next
	
	listofBalls.Initialize
End Sub

'x and y must be in world coordinates
Sub setupBall(X As Float, Y As Float)
	Dim ballDef As jbBodyDef
	ballDef.position.set(X, Y)
	ballDef.Type = ballDef.BODYTYPE_DYNAMIC
	
	Dim ballBody As jbBody
	ballBody = dominoWorld.createBody(ballDef)
	
	Dim ballShape As jbCircleShape
	ballShape.m_radius = DominoHeight/2 
	
	ballBody.createFixture2(ballShape, .1)
	listofBalls.Add(ballBody)

End Sub

Sub mnuChangeHeight_Click
	Dim dlg As NumberDialog
	Dim ans As Int
	dlg.Number = WorldConverter.getCurrentHeightInMeters
	ans =dlg.Show("Enter new height in meters", "OK", "Nevermind", "", Null)

	WorldConverter.SetHeightInMeters(dlg.Number, True)
	WorldConverter.SetCenterPoint(0, 2)
	resetBMPsize
	
End Sub

Sub resetBMPsize
	setupBallBMP
	setupDominoBMP
	setupShelfBMP
End Sub

Sub mnuReset_click
	'tmrWorldStep.Enabled = False
	accSfc.StopRegularDraw
	clearDominos
	clearBalls
	setupdominos
	accSfc.StartRegularUpdateAndDraw(timeStep)
	'setupBall(.25, 5)
	'tmrWorldStep.Enabled = True
End Sub

Sub WorldStep 
	dominoWorld.Step(1/30, 9, 3)	
	'accSfc.Invalidate
End Sub


Sub tmrWorldStep_tick
WorldStep

End Sub

Sub accSfc_update(ElapsedTime As Long)
	Log(ElapsedTime)
	
	WorldStep


End Sub

Sub accSfc_draw(AC As AcceleratedCanvas)
	
	DrawShelves(AC)
	
	drawDominos(AC)
	
	drawBalls(AC)

End Sub

Sub setupDominoBMP
	Dim IU As ImageUtils

	Dim aDominoHeight, aDominoWidth As Float
	aDominoHeight = WorldConverter.JWorldLengthToDisplayLength(DominoHeight) 
	aDominoWidth = WorldConverter.JWorldLengthToDisplayLength(DominoWidth) 
	

	bmpDomino = IU.CreateScaledBitmap(LoadBitmap(File.DirAssets, "domino.png"), aDominoWidth, aDominoHeight, True)
End Sub

Sub setupBallBMP
	Dim IU As ImageUtils

	Dim ballHeight As Float
	ballHeight = WorldConverter.JWorldLengthToDisplayLength(DominoHeight)

	
	
	bmpBall = IU.CreateScaledBitmap(LoadBitmap(File.DirAssets, "mysmiley.png"), ballHeight, ballHeight, True)

End Sub

Sub setupShelfBMP
	Dim IU As ImageUtils

	Dim shelfHeight, shelfWidth As Float
	shelfHeight = WorldConverter.JWorldLengthToDisplayLength(.02) 
	If shelfHeight < 1 Then shelfHeight = 1
	shelfWidth = WorldConverter.JWorldLengthToDisplayLength(10)
	
	
	bmpShelf = IU.CreateScaledBitmap(LoadBitmap(File.DirAssets, "shelf.png"), shelfWidth, shelfHeight, True)
End Sub
Sub DrawShelves(AC As AcceleratedCanvas)

	For Each Shelf As jbBody In listOfShelves
		Dim newPosition As jbVec2
		'newPosition = body.Position

		newPosition = WorldConverter.ChangeWorldVecToDisplayVec(Shelf.Position)


		AC.DrawBitmapAt(bmpShelf,newPosition.x - bmpShelf.Width/2 , newPosition.y - bmpShelf.Height/2)

	Next

End Sub

Sub drawBalls(AC As AcceleratedCanvas)
	Dim ball As jbBody
	For i = 0 To listofBalls.Size-1
		ball = listofBalls.Get(i)
		Dim newPosition As jbVec2
		
		newPosition = WorldConverter.ChangeWorldVecToDisplayVec(ball.Position)
		AC.MatrixSetRotate2(ball.Angle * -57.295, Bit.ShiftRight(bmpBall.Width, 1), Bit.ShiftRight(bmpBall.Height, 1))
		AC.DrawBitmapWithMatrixAt(bmpBall,newPosition.x - bmpBall.Width/2 , newPosition.y - bmpBall.Height/2, True) ' + bmpDomino.Height * .1, True)
			
	Next

End Sub

Sub drawDominos(AC As AcceleratedCanvas)

	Dim domino As jbBody
	Dim lastDomino As jbBody
	For i = 0 To listOfDominos.Size-1
		domino = listOfDominos.Get(i)
		Dim newPosition As jbVec2
		'newPosition = body.Position
		If i > 0 Then
			lastDomino = listOfDominos.Get(i-1)
			displaylength = WorldConverter.JWorldLengthToDisplayLength(domino.Position.x - lastDomino.Position.x)
		End If
		
		newPosition = WorldConverter.ChangeWorldVecToDisplayVec(domino.Position)
		AC.MatrixSetRotate2(domino.Angle * -57.295, Bit.ShiftRight(bmpDomino.Width, 1), Bit.ShiftRight(bmpDomino.Height, 1))
		AC.DrawBitmapWithMatrixAt(bmpDomino,newPosition.x - bmpDomino.Width/2 , newPosition.y - bmpDomino.Height/2, True)
			
	Next

''	For Each domino As jbBody In listOfDominos
''		Dim newPosition As jbVec2
''		'newPosition = body.Position
''		
''		newPosition = WorldConverter.ChangeWorldVecToDisplayVec(domino.Position)
''		AC.MatrixSetRotate2(domino.Angle * -57.295, Bit.ShiftRight(bmpDomino.Width, 1), Bit.ShiftRight(bmpDomino.Height, 1))
''		AC.DrawBitmapWithMatrixAt(bmpDomino,newPosition.x - bmpDomino.Width/2 , newPosition.y - bmpDomino.Height/2 + bmpDomino.Height * .1, True)
''			
''	
''		'AC.DrawBitmapAt(bmpDomino,newPosition.x - bmpDomino.Width/2 , newPosition.y - bmpDomino.Height/2 + bmpDomino.Height *.13)
''
''	Next

End Sub

Sub pnlTouch_Touch (Action As Int, X As Float, Y As Float)
	
	
End Sub

Sub Gesture_onSingleTapConfirmed(X As Float, Y As Float, MotionEvent As Object)
'
	Dim WorldVec As jbVec2
	WorldVec.Initialize(X, Y)
	WorldVec = WorldConverter.GetWorldPointFromDisplay(WorldVec)
	setupBall(WorldVec.X, WorldVec.Y)

	
End Sub
Sub Gesture_onDoubleTap(X As Float, Y As Float, MotionEvent As Object)
	Dim WorldPoint As jbVec2
	Dim DisplayPoint As jbVec2
	DisplayPoint.Initialize(X, Y)
	WorldPoint = WorldConverter.GetWorldPointFromDisplay(DisplayPoint)
	
	WorldConverter.SetCenterPoint(WorldPoint.X, WorldPoint.Y)
	WorldConverter.ChangeScale(WorldConverter.getCurrentScale * 1.1, True)
	setupBallBMP
	setupDominoBMP
	setupShelfBMP
End Sub
Sub Gesture_onShowPress(X As Float, Y As Float, MotionEvent As Object)
	Log("   onShowPress x=" & X & ", y=" & Y & ", ev=" & MotionEvent)
End Sub
Sub Gesture_onLongPress(X As Float, Y As Float, MotionEvent As Object)
	WorldConverter.ChangeScale(WorldConverter.getCurrentScale * .9, True)
	setupBallBMP
	setupDominoBMP
	setupShelfBMP
End Sub


